# Python import
import string
from StringIO import StringIO

# CMF Imports
from Products.CMFCore.utils import getToolByName

# Products import
from Products.I18NFolder import I18NFolder
from Products.I18NFolder.config import *
from Products.CMFDynamicViewFTI.migrate import migrateFTIs
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin


def install(self):
    out = StringIO()
    print >> out, "Installing I18NFolder"

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"

    # Install skin
    install_subskin(self, out, product_globals)
    print >> out, "Installed skin"

    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    
    if 'I18NFolder' not in types:
        types.append('I18NFolder')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)

    # Change I18NFolder workflow to folder workflow
    self.portal_workflow.setChainForPortalTypes((PROJECTNAME,), 'folder_workflow')
    
    kupuTool = getToolByName(self, 'kupu_library_tool')
    linkable = list(kupuTool.getPortalTypesForResourceType('linkable'))
    
    kupuTool.updateResourceTypes(({'resource_type' : 'linkable',
                                   'old_type'      : 'linkable',
                                   'portal_types'  :  linkable},))
    
    
    return out.getvalue()
    
def uninstall(self):
    """ Nothing to do. """
    out=StringIO()
    return out.getvalue()
